Strict

Type Tile
	Field x,y
	Field sx,sy,Kolli
	
	Method Draw()
		SetBlend MASKBLEND
		If WWidth=640 Then
			DrawSubImageRect Tileset,x,y,16,16,sx,sy,16,16
		Else
			DrawSubImageRect Tileset,x+80,y,16,16,sx,sy,16,16
		EndIf
	End Method
	
	Function Create:Tile(ix,iy,isx,isy)
		Local T:Tile=New Tile
		T.x=ix
		T.y=iy
		T.sx=isx
		If isy=0 Then T.Kolli=1
		If T.Kolli=1 Then CollideRect(T.x,T.y,16,16,0,1)
		T.sy=isy
		Return T
	End Function
End Type

Type Item
	Field x,y
	Field Typ,Grab,Richtung,Fest
	
	Method GrabCheck(ix,iy)
		If Typ=1 Then
			If ix=x/16 Then
				If iy=y/16 Then
					If Not(CollideRect(x+4,y-9,8,-8,2,0)) Then
						Tragen=1
						Grab=1
					EndIf
				EndIf
			EndIf
		EndIf
	End Method
	
	Method SetPosition(ix,iy)
		x=ix*16
		y=iy*16
	End Method
	
	Method Update(ix,iy)
		If Grab=1 Then
			Fest=0
			If r=0 Then
				x=ix-13
				y=iy-10
			Else
				x=ix
				y=iy-10
			EndIf
		Else
			If Fest=0 Then
				If Not(CollideRect(x+3,y+16,10,1,2,0)) And Not(CollideRect(x+4,y+16,8,1,1,0)) Then
					y=y+1
				Else
					y=Rn(y)*16
					Fest=1
				EndIf
			EndIf
		EndIf
	End Method
	
	Method Draw()
		Select Typ
			Case 1
				If WWidth=640 Then
					DrawSubImageRect Itemset,x,y,16,16,0,0,16,16
				Else
					DrawSubImageRect Itemset,x+80,y,16,16,0,0,16,16
				EndIf
				If Grab=0 Then CollideRect(x,y,16,16,0,2)
			Case 2
				If WWidth=640 Then
					DrawSubImageRect Itemset,x,y,16,32,0,16,16,32
				Else
					DrawSubImageRect Itemset,x+80,y,16,32,0,16,16,32
				EndIf
			Case 3
				If WWidth=640 Then
					DrawSubImageRect Itemset,x,y-16,16,32,16,16,16,32
				Else
					DrawSubImageRect Itemset,x+80,y-16,16,32,16,16,16,32
				EndIf
			Case 4
				If WWidth=640 Then
					If Richtung=1 Then
						DrawSubImageRect Itemset,x,y-16,16,32,32,16,16,32
					Else
						DrawSubImageRect Itemset,x,y-16,16,32,48,16,16,32
					EndIf
				Else
					If Richtung=1 Then
						DrawSubImageRect Itemset,x+80,y-16,16,32,32,16,16,32
					Else
						DrawSubImageRect Itemset,x+80,y-16,16,32,48,16,16,32
					EndIf
				EndIf
		End Select
	End Method
	
	Function Create:Item(ix,iy,iTyp,iextra=0)
		Local I:Item=New Item
		I.x=ix
		I.y=iy
		I.Typ=iTyp
		If iTyp=4 Then I.Richtung=iextra
		Return I
	End Function
End Type

Global WWidth,WHeight,WMode
WWidth=800
WHeight=480
WMode=0

Graphics WWidth,WHeight,WMode,64

HideMouse()
AutoMidHandle(1)

Global PlayerL:TImage,PlayerR:TImage,Tileset:TImage,Itemset:TImage
PlayerL=LoadAnimImage("gfx\PlayerL.png",15,20,0,6)
PlayerR=LoadAnimImage("gfx\PlayerR.png",15,20,0,6)
Tileset=LoadImage("gfx\Tileset.png")
Itemset=LoadImage("gfx\Itemset.png")

Global Tilelist:TList
Global Itemlist:TList

Global x:Float,y:Float,b:Byte,bt:Int,Tragen:Byte,r:Byte,AmBoden:Byte
Global xs:Float,ys:Float
Global Level

Local fps,fpt,fpz

Level=1
LoadMap("Level"+Level)

Repeat
	Cls
	ResetCollisions(2)
	DrawTiles()
	DrawItems()
	UpdatePlayer()
	UpdateItems()
	DrawPlayer()
	DrawHints()
	
	DrawText "Level: "+Level,WWidth-100,0
	DrawText "FPS: "+fps,0,0
	
	fpz=fpz+1
	If fpt<MilliSecs() Then
		fpt=MilliSecs()+999
		fps=fpz
		fpz=0
	EndIf
	
	Flip 60
Until KeyDown(KEY_Escape)

Function LoadMap(DateiName:String)
	Tilelist:TList=New TList
	Itemlist:TList=New TList
	ResetCollisions(0)
	Local T:Tile
	Local Datei:TStream
	Local ix,iy,sx,sy,iTyp
	If FileType("Level\"+DateiName+".map")>0 Then
		Datei=ReadFile("Level\"+DateiName+".map")
		For ix=0 To 39
			For iy=0 To 29
				sx=ReadByte(Datei)*16
				sy=ReadByte(Datei)*16
				Tilelist.Addlast(Tile.Create(ix*16,iy*16,sx,sy))
			Next
		Next
	Else
		RuntimeError "Datei "+DateiName+".map konnte nicht geladen werden."
	EndIf
	Local I:Item
	If FileType("Level\"+DateiName+".imap")>0 Then
		Datei=ReadFile("Level\"+DateiName+".imap")
		x=ReadByte(Datei)*16
		y=ReadByte(Datei)*16
		Local IMenge=ReadByte(Datei)
		Local ii,iextra
		If IMenge>1 Then
			For ii=1 To IMenge
				ix=ReadByte(Datei)
				iy=ReadByte(Datei)
				iTyp=ReadByte(Datei)
				If iTyp=4 Then iextra=ReadByte(Datei)
				Itemlist.Addlast(Item.Create(ix*16,iy*16,iTyp,iextra))
				If iTyp=3 Or iTyp=4 Then CollideRect(ix*16,iy*16-16,16,32,0,4)
			Next
		EndIf
	Else
		RuntimeError "Datei "+DateiName+".imap konnte nicht geladen werden."
	EndIf
	CloseFile Datei
End Function

Function DrawTiles()
	'Tiles zeichnen
	SetBlend MASKBLEND
	Local T:Tile
	For T=EachIn Tilelist
		T.Draw()
	Next
End Function

Function UpdateItems()
	Local I:Item
	For I=EachIn Itemlist
		If I.Typ=1 Then I.Update(x,y)
	Next
End Function

Function DrawItems()
	'Tiles zeichnen
	SetBlend MASKBLEND
	Local I:Item
	For I=EachIn Itemlist
		I.Draw()
	Next
End Function

Function UpdatePlayer()
	Local T=MilliSecs()
	Local I:Item
	'Links/Rechts gehen und abbremsen, wenn nichts gedrckt
	If KeyDown(KEY_Left) Or KeyDown(KEY_A) Then 
		If xs>-1.5 Then  xs=xs-.1
	ElseIf KeyDown(KEY_Right) Or KeyDown(KEY_D) Then 
		If xs<1.5 Then xs=xs+.1
	Else
		If xs<0 Then xs=xs+.2
		If xs>0 Then xs=xs-.2
		If xs<.2 And xs>-.2 Then xs=0
	EndIf

	If KeyHit(KEY_Enter) Then LoadMap("Level"+Level)

	If AmBoden=1 Then
		'Springen und durch Tren gehen
		If KeyHit(KEY_Up) Or KeyHit(KEY_W) Then
			Local Found=0
			If CollideRect(x-7.5,y-10,15,20,4,0) Then
				For I=EachIn Itemlist
					If Rn(x)=I.x/16 And Rn(y)=I.y/16 Then
						If I.Richtung=0 Then
							If Level=6 Then End
							Level=Level+1
							LoadMap("Level"+Level)
						Else
							Local I2:Item
							For I2=EachIn Itemlist
								If I.x=I2.x And Not(I.Richtung=I2.Richtung) And Found=0 And Tragen=0 Then
									x=I2.x+8
									y=I2.y
									Found=1
								EndIf
							Next
						EndIf
					EndIf
				Next
			Else	
				ys=ys-5
				AmBoden=0
			EndIf
		EndIf
	
		'Kisten aufnehmen und ablegen
		If KeyHit(KEY_Space) Then
			If Tragen=0 Then
				If r=0 Then
					If CollideRect(x-7.5,y-10,-2,20,2,0) Then
						For I=EachIn Itemlist
							I.Grabcheck(Rn(x)-1,Rn(y))
						Next
					EndIf
				Else
					If CollideRect(x+7.5,y-10,2,20,2,0) Then
						For I=EachIn Itemlist
							I.Grabcheck(Rn(x)+1,Rn(y))
						Next
					EndIf
				EndIf
			Else
				For I=EachIn Itemlist
					If I.Grab=1 Then
						If r=0 Then
							If Not(CollideRect(x-7,y-7,-10,16,1,0)) And Not(CollideRect(x-7,y-7,-10,16,2,0)) And (CollideRect((Rn(x)+1)*16-15,y+10,14,14,2,0) Or CollideRect((Rn(x)+1)*16-15,y+10,14,14,1,0)) Then
								I.SetPosition(Rn(x)-1,Rn(y))
								x=(Rn(x)+1)*16-10
								Tragen=0
								I.Grab=0
							EndIf
						Else
							If Not(CollideRect(x+7,y-7,10,16,1,0)) And Not(CollideRect(x+7,y-7,10,16,2,0)) And (CollideRect((Rn(x))*16+2,y+10,14,14,2,0) Or CollideRect((Rn(x))*16+2,y+10,14,14,1,0)) Then
								I.SetPosition(Rn(x)+1,Rn(y))
								x=(Rn(x))*16+10
								Tragen=0
								I.Grab=0
							EndIf
						EndIf
					EndIf
				Next
			EndIf
		EndIf
	EndIf
	
	If xs>0 Then
		r=1
	ElseIf xs<0 Then
		r=0
	EndIf
	
	If ys<10 And AmBoden=0 Then ys=ys+.5
	CheckCollisions()
	x=x+xs
	y=y+ys
	
	If AmBoden=1 Then
		If MilliSecs()>bt And Abs(xs)>0 Then
			bt=MilliSecs()+100
			b=b+1
		EndIf
		If b>1 Then b=0
		If xs=0 Then b=0
	Else
		b=2
		bt=MilliSecs()+100
	EndIf
	DrawText MilliSecs()-T,0,10
End Function

'Rundefunktion. Rundet Werte sodass sie durch 16 teilbar sind.
Function Rn(i)
	i=Float(i/16)
	Return i
End Function


Function CheckCollisions()
	If AmBoden=0 Then
		If CollideRect(x-5,y-10,10,-ys+1,1,0) Or CollideRect(x-5,y-10,10,-ys+1,2,0) Then
			y=Rn(y+ys)*16+10
			ys=0
		EndIf
	
		If CollideRect(x-5,y+10,10,ys+1,1,0) Or CollideRect(x-5,y+10,10,ys+1,2,0) Then
			y=Rn(y+ys)*16+6
			ys=0
			AmBoden=1
		EndIf
	Else
		If Not(CollideRect(x-5,y+10,10,ys+1,1,0) Or CollideRect(x-5,y+10,10,ys+1,2,0)) Then AmBoden=0
	EndIf
	
	If r=1 Then
		If CollideRect(x+6,y-10,xs+1,20,1,0) Or CollideRect(x+6,y-10,xs+1,20,2,0) Then
			x=Rn(x+xs)*16+10
			xs=0
		EndIf
	Else
		If CollideRect(x-6,y-10,-xs+1,20,1,0) Or CollideRect(x-6,y-10,-xs+1,20,2,0) Then
			x=Rn(x-xs)*16+6
			xs=0
		EndIf
	EndIf
End Function

Function DrawPlayer()
	If WWidth=640 Then
		If r=0 Then
			DrawImage PlayerL,x,y,b+Tragen*3
		Else
			DrawImage PlayerR,x,y,b+Tragen*3
		EndIf
	Else
		If r=0 Then
			DrawImage PlayerL,x+80,y,b+Tragen*3
		Else
			DrawImage PlayerR,x+80,y,b+Tragen*3
		EndIf
	EndIf
End Function

Function DrawHints()
	If Level=1 Then
		DrawText "Tipp: Mit Leertaste kannst du Kisten aufnehmen und wenn du eine Kiste hast auch wieder ablegen.",0,WHeight-30
		DrawText "      Ziel ist es den Ausgang zu erreichen.",0,WHeight-15
	ElseIf Level=2 Then
		DrawText "Tipp: Ab und zu, musst du bereits benutze Kisten wieder mitnehmen, um den Ausgang zu erreichen.",0,WHeight-15
	ElseIf Level=3 Then
		DrawText "Tipp: Wenn du Kisten stapelst werden die Kisten, die unten liegen, blockiert.",0,WHeight-30
		DrawText "      Zudem solltest du keine Kisten liegen lassen. Du koenntest es spaeter bereuen.",0,WHeight-15
	ElseIf Level=4 Then
		DrawText "Tipp: Mit Aufzuegen kannst du problemlos Hoehen ueberwinden.",0,WHeight-15
	ElseIf Level=5 Then
		DrawText "Tipp: Aufzuege koennen jedoch keine Kisten mitnehmen. Die muessen anders ans Ziel gelangen.",0,WHeight-15
	EndIf
End Function